import 'package:json_annotation/json_annotation.dart';
part 'address.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class Address {
  Address(this.street, this.street2, this.city, this.state, this.zipcode, this.latitude, this.longitude);

  final String street;
  final String street2;
  final String city;
  final String state;
  final String zipcode;
  @JsonKey(name: 'lat')
  final double latitude;
  @JsonKey(name: 'lng')
  final double longitude;

  bool isEqual(Address that) {
    return this.street == that.street
      && this.city == that.city
      && this.state == that.state
      && this.zipcode == that.zipcode;
  }

  @override
  toString() {
    return '$street $street2, $city, $state $zipcode';
  }

  factory Address.fromJson(Map<String, dynamic> json) => _$AddressFromJson(json);
  Map<String, dynamic> toJson() => _$AddressToJson(this);
}