import 'package:json_annotation/json_annotation.dart';
part 'assignment.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class Assignment {
  Assignment(this.id, this.label, this.shipmentCount, this.driverId, this.status, this.clientIds, this.tourCost, this.regionCode, this.logisticType, this.predictedStartTs, this.predictedLatestStartTs, this.predictedEndTs, this.code);

  int id;

  final String label;

  @JsonKey(name: 'shipment_count')
  int shipmentCount;

  @JsonKey(name: 'is_active')
  bool isActive;

  @JsonKey(name: 'driver_id')
  int driverId;
  String status;

  @JsonKey(name: 'client_ids')
  List<int> clientIds;

  @JsonKey(name: 'tour_cost')
  double tourCost;

  @JsonKey(name: 'region_code')
  String regionCode;

  @JsonKey(name: 'logistic_type')
  String logisticType;

  @JsonKey(name: 'predicted_start_ts')
  DateTime predictedStartTs;

  @JsonKey(name: 'predicted_latest_start_ts')
  DateTime predictedLatestStartTs;

  @JsonKey(name: 'predicted_end_ts')
  DateTime predictedEndTs;

  final String code;

  factory Assignment.fromJson(Map<String, dynamic> json) => _$AssignmentFromJson(json);
  Map<String, dynamic> toJson() => _$AssignmentToJson(this);
}
