import 'package:json_annotation/json_annotation.dart';
part 'aws_security_token.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class AWSSecurityToken {
  static const String TYPE_FEDERATION = "FEDERATION";
  static const String TYPE_SESSION = "SESSION";

  AWSSecurityToken(this.type, this.token, this.accessKey, this.secretKey, this.expiredAt);

  @JsonKey(name: 'type') final String type;
  @JsonKey(name: 'token') final String token;
  @JsonKey(name: 'access_key')final String accessKey;
  @JsonKey(name: 'secret_key') final String secretKey;
  @JsonKey(name: 'expired_at') final DateTime expiredAt;

  factory AWSSecurityToken.fromJson(Map<String, dynamic> json) => _$AWSSecurityTokenFromJson(json);
  Map<String, dynamic> toJson() => _$AWSSecurityTokenToJson(this);
}