import 'package:json_annotation/json_annotation.dart';
part 'axl_token.g.dart';

@JsonSerializable()

/// Token from Oauth server
class AxlToken {
  AxlToken(this.accessToken, this.expiresIn, this.refreshToken, this.scope, this.tokenType, this.expiresAt);

  @JsonKey(name: 'access_token')
  final String accessToken;

  @JsonKey(name: 'expires_in')
  final int expiresIn;

  @JsonKey(name: 'refresh_token')
  final String refreshToken;

  final String scope;

  @JsonKey(name: 'token_type')
  final String tokenType;

  @JsonKey(name: 'expires_at')
  final double expiresAt;

  int get expiresTs {
    return expiresAt == null ? null : (1000.0 * expiresAt).floor();
  }

  List<String> get scopes {
    return this.scope == null ? [] : this.scope.split(" ").toList();
  }

  factory AxlToken.fromJson(Map<String, dynamic> json) => _$AxlTokenFromJson(json);
  Map<String, dynamic> toJson() => _$AxlTokenToJson(this);
}
