import 'package:json_annotation/json_annotation.dart';
part 'customer.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class Customer {
  Customer(this.name, this.email, this.phoneNumber);

  final String name;

  final String email;

  @JsonKey(name: 'phone_number')
  final String phoneNumber;
  
  factory Customer.fromJson(Map<String, dynamic> json) => _$CustomerFromJson(json);
  Map<String, dynamic> toJson() => _$CustomerToJson(this);
}