import 'package:json_annotation/json_annotation.dart';
import 'driver_schedule.dart';

part 'decor_schedule.g.dart';

@JsonSerializable()

class DecorSchedule {
  DecorSchedule({this.schedule, this.assignmentDriverMap, this.bookingStartTime, this.targetDate});

  final DriverSchedule schedule;

  @JsonKey(name: 'target_date')
  final int targetDate;

  @JsonKey(name: 'booking_start_time')
  final int bookingStartTime;

  @JsonKey(name: 'assignment_driver_map')
  final Map<int, int> assignmentDriverMap;

  factory DecorSchedule.fromJson(Map<String, dynamic> json) => _$DecorScheduleFromJson(json);
  Map<String, dynamic> toJson() => _$DecorScheduleToJson(this);
}