import 'package:json_annotation/json_annotation.dart';
part 'geocode_address.g.dart';

@JsonSerializable()

class GeocodeAddress {
  GeocodeAddress(
    this.id,
    this.latitude, this.longitude,
    this.uncharted,
    this.navigationDifficulty,
    this.rdi,
    this.photoUrls,
    this.accessCode,
    this.additionalInstruction,
    this.tags,
    this.suggestedAccessCodes
  );

  final String id;

  final double latitude;
  final double longitude;
  final bool uncharted;
  @JsonKey(name: 'navigation_difficulty')
  final String navigationDifficulty;
  final bool rdi;
  @JsonKey(name: 'photo_urls')
  final List<String> photoUrls;

  @JsonKey(name: 'access_code')
  final String accessCode;

  final List<String> tags;

  @JsonKey(name: 'additional_instruction')
  final String additionalInstruction;

  @JsonKey(name: 'suggested_access_codes')
  final List<String> suggestedAccessCodes;

  GeocodeAddress withAccessCode(String newAccessCode) {
    List<String> suggested = suggestedAccessCodes ?? [];
    if (!suggested.contains(newAccessCode)) {
      suggested.add(newAccessCode);
    }
    return GeocodeAddress(
      this.id,
      this.latitude, this.longitude,
      this.uncharted,
      this.navigationDifficulty,
      this.rdi,
      this.photoUrls,
      newAccessCode,
      this.additionalInstruction,
      this.tags,
      suggested
    );
  }

  factory GeocodeAddress.fromJson(Map<String, dynamic> json) => _$GeocodeAddressFromJson(json);
  Map<String, dynamic> toJson() => _$GeocodeAddressToJson(this);
}
