import 'package:json_annotation/json_annotation.dart';
part 'location.g.dart';

@JsonSerializable()
class Location {
  Location(
      this.latitude,
      this.longitude,
      this.altitude,
      this.accuracy,
      this.heading,
      this.speed,
      {
        this.timestamp
      }
      ){
    if(this.timestamp == null) {
      this.timestamp = DateTime.now();
    }
  }

  final double latitude;
  final double longitude;
  final double altitude;
  final double accuracy;
  final double heading;
  final double speed;
  DateTime timestamp;

  factory Location.fromJson(Map<String, dynamic> json) => _$LocationFromJson(json);
  Map<String, dynamic> toJson() => _$LocationToJson(this);
}