import 'package:axlehire_flutter_model/src/messenger.dart';
import 'package:flutter/material.dart';
import 'package:json_annotation/json_annotation.dart';
import 'dart:convert' as convert;
part 'messenger_topic.g.dart';

@JsonSerializable()
class Topic {
  String id;
  String title;
  @JsonKey(name: "unviewed_messages_count")
  int unViewedMessagesCount;
  @JsonKey(name: "image_urls")
  Map<String, dynamic> imageUrls;
  @JsonKey(name: "latest_message")
  Message lastMessage;

  int topicType;

  Topic({@required this.id, this.title, this.lastMessage,
    this.imageUrls, this.unViewedMessagesCount, this.topicType});

  factory Topic.fromJson(Map<String, dynamic> json, {bool isConvertedMessageFromString = false}) {
    if (isConvertedMessageFromString) {
      var map = Map<String, dynamic>.from(json);
      map['latest_message'] = convert.jsonDecode(map['latest_message']); //Unsupported operation: read-only
      map['image_urls'] = convert.jsonDecode(map['image_urls']); //Unsupported operation: read-only
      return _$TopicFromJson(map);
    }
    return _$TopicFromJson(json);
  }

  Map<String, dynamic> toJson({bool isConvertedMessageToString = false}) {
    if (isConvertedMessageToString) {
      var map = _$TopicToJson(this);
      map["latest_message"] = convert.jsonEncode(map["latest_message"]);
      map["image_urls"] = convert.jsonEncode(map["image_urls"]);
      return map;
    }
    return _$TopicToJson(this);
  }

}