/// attributes is more restrictive than metadata in the sense that
/// It can only contain String value

class AttributesMixin {
  Map<String, String> attributes;

  bool getMetaBool(String key, { bool defaultValue = true }) {
    if (this.attributes != null && this.attributes.containsKey(key)) {
      return this.attributes[key].toLowerCase() == 'true';
    }
    return defaultValue;
  }

  int getMetaInt(String key, { int defaultValue = 0 }) {
    if (this.attributes != null && this.attributes.containsKey(key)) {
      return int.parse(this.attributes[key]);
    }
    return defaultValue;
  }
}
