import 'package:axlehire_flutter_model/src/dimension.dart';
import 'package:axlehire_flutter_model/src/weight.dart';
import 'package:json_annotation/json_annotation.dart';
part 'parcel.g.dart';

@JsonSerializable()

class Parcel {
  Parcel(this.shipmentId, this.type, { this.id,  this.parcelId, this.dimensions, this.weight, this.description, this.category, this.status });

  final String id;

  @JsonKey(name: 'shipment_id')
  final int    shipmentId;

  @JsonKey(name: 'parcel_id')
  final String parcelId;

  final Dimension dimensions;
  final Weight weight;

  final String description;
  final String category;
  final String type;
  final String status;

  Parcel withStatus(String st) {
    return Parcel(this.shipmentId, this.type, id: this.id, parcelId: this.parcelId, dimensions: this.dimensions, weight: this.weight, description: this.description, category: this.category, status: st);
  }

  factory Parcel.fromJson(Map<String, dynamic> json) => _$ParcelFromJson(json);
  Map<String, dynamic> toJson() => _$ParcelToJson(this);
}