import 'package:axlehire_flutter_model/axlehire_model.dart';
import 'package:axlehire_flutter_model/src/payroll_transaction.dart';
import 'package:json_annotation/json_annotation.dart';
part 'payroll_assignment_transaction.g.dart';

@JsonSerializable()

class AssignmentTransaction {
  @JsonKey(name: "assignment_id")
  int assignmentId;
  @JsonKey(name: "transactions")
  List<Transaction> transactions;
  String mapUrl;
  DecorAssignment assignment;

  AssignmentTransaction(this.assignmentId, this.transactions);

  factory AssignmentTransaction.fromJson(Map<String, dynamic> json) => _$AssignmentTransactionFromJson(json);
  Map<String, dynamic> toJson() => _$AssignmentTransactionToJson(this);

  String get assignmentTotalEarning {
    double earning = 0;
    this.transactions?.forEach((transaction) {
      earning += transaction.amount;
    });
    return "$earning";
  }
}
