import 'package:axlehire_flutter_model/src/payroll_assignment_transaction.dart';
import 'package:axlehire_flutter_model/src/paystub_breakdown.dart';
import 'package:axlehire_flutter_model/src/paystub_breakdown_type.dart';
import 'package:json_annotation/json_annotation.dart';
part 'payroll_date_transaction.g.dart';

@JsonSerializable()

class DateTransaction {
  @JsonKey(name: "date")
  String date;
  @JsonKey(name: "breakdown")
  Breakdown breakdown;
  @JsonKey(name: "transactions_by_assignment")
  List<AssignmentTransaction> assignmentTransactions;

  DateTransaction(this.date, this.breakdown, this.assignmentTransactions);

  factory DateTransaction.fromJson(Map<String, dynamic> json) => _$DateTransactionFromJson(json);
  Map<String, dynamic> toJson() => _$DateTransactionToJson(this);

  String taskAndSummaryCount() {
    if (breakdown.breakdownsByType.length == 0) return "Empty";
    int taskCount = 0;
    int tipCount = 0;
    for (BreakdownType breakdownType in breakdown.breakdownsByType) {
      switch(breakdownType.type) {
        case "OUTVOICE - ROUTE_DRIVING":
          taskCount += breakdownType.transactionCount;
          break;
        case "OUTVOICE - TIP":
          tipCount += breakdownType.transactionCount;
          break;
      }
    }

    String tipCountString = tipCount > 0 ? "$tipCount Tips" : "";
    String taskCountString = taskCount > 0 ? "$taskCount Tasks" : "";
    return "$taskCountString ${taskCountString.isNotEmpty ? "&" : ""} $tipCountString";
  }

  String get status => this.breakdown.breakdownsByStatus[0]?.status;
}
