import 'package:axlehire_flutter_model/src/aws_security_token.dart';
import 'package:json_annotation/json_annotation.dart';
part 's3_security_token.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class S3SecurityToken extends AWSSecurityToken {
  S3SecurityToken(String type, String token, String accessKey, String secretKey, DateTime expiredAt,
    this.driverRootBucket, this.driverPath, this.deliveryRootBucket, this.deliveryPath):
    super(type, token, accessKey, secretKey, expiredAt);

  @JsonKey(name: 'driver_root_bucket') String driverRootBucket;
  @JsonKey(name: 'driver_path') String driverPath;
  @JsonKey(name: 'delivery_root_bucket') String deliveryRootBucket;
  @JsonKey(name: 'delivery_path') String deliveryPath;

  factory S3SecurityToken.fromJson(Map<String, dynamic> json) => _$S3SecurityTokenFromJson(json);
  Map<String, dynamic> toJson() => _$S3SecurityTokenToJson(this);
}