import 'package:json_annotation/json_annotation.dart';
part 'shipment_image.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class ShipmentImage {
  ShipmentImage(
    this.id,
    this.uid,
    this.shipmentId,
    this.stopId,
    this.driverId,
    this.clientId,
    this.url,
    { this.localPath, this.status }
  );

  final int id;
  final String uid;

  @JsonKey(name: 'shipment_id')
  int shipmentId;

  @JsonKey(name: 'stop_id')
  int stopId;

  @JsonKey(name: "driver_id")
  int driverId;

  @JsonKey(name: "client_id")
  int clientId;

  @JsonKey(name: "url")
  final String url;

  @JsonKey(name: "local_path")
  String localPath;

  @JsonKey(name: "status")
  String status;

  factory ShipmentImage.fromJson(Map<String, dynamic> json) => _$ShipmentImageFromJson(json);
  Map<String, dynamic> toJson() => _$ShipmentImageToJson(this);
}
