import 'package:json_annotation/json_annotation.dart';
part 'shipment_signature.g.dart';

/// An annotation for the code generator to know that this class needs the
/// JSON serialization logic to be generated.
@JsonSerializable()

class ShipmentSignature {
  ShipmentSignature(
    this.id,
    this.uid,
    this.shipmentId,
    this.stopId,
    this.driverId,
    this.clientId,
    this.image,
  );

  final int id;
  final String uid;

  @JsonKey(name: 'shipment_id')
  int shipmentId;

  @JsonKey(name: 'stop_id')
  int stopId;

  @JsonKey(name: "driver_id")
  int driverId;

  @JsonKey(name: "client_id")
  int clientId;

  final String image;

  factory ShipmentSignature.fromJson(Map<String, dynamic> json) => _$ShipmentSignatureFromJson(json);
  Map<String, dynamic> toJson() => _$ShipmentSignatureToJson(this);
}
