/// Model for Synchronized File Item
import 'package:json_annotation/json_annotation.dart';
part 'sync_file_item.g.dart';

@JsonSerializable()

class SyncFileItem {
  SyncFileItem(this.id, this.path, this.created, this.url, { this.uploadUrl, this.uploadParams, this.expiration });

  // Identifier of the file, which
  final String id;

  // Local path
  final String path;

  final DateTime created;

  // URL of the file item after uploaded
  @JsonKey(name: 'url')
  final String url;

  // URL used for uploading purpose only
  @JsonKey(name: 'upload_url')
  final String uploadUrl;

  @JsonKey(name: 'upload_params')
  final Map<String, String> uploadParams;

  // expiration of the upload URL
  // after this expiration, need to obtain a new url
  final int expiration;

  // keep track of number of retry to upload the file
  int tried;

  factory SyncFileItem.fromJson(Map<String, dynamic> json) => _$SyncFileItemFromJson(json);
  Map<String, dynamic> toJson() => _$SyncFileItemToJson(this);
}