import 'package:json_annotation/json_annotation.dart';
part 'task_type.g.dart';

@JsonSerializable()


class TaskType {
  const TaskType._internal(this.type);

  final String type;

  static const CLOCK_IN = const TaskType._internal("CLOCK_IN");
  static const CLOCK_OUT = const TaskType._internal("CLOCK_OUT");
  static const PICKUP = const TaskType._internal("PICK_UP");
  static const DROPOFF = const TaskType._internal("DROP_OFF");
  static const RETURN = const TaskType._internal("RETURN");
  static const COMPLETE = const TaskType._internal("COMPLETE");

  static const ALL = {
    'CLOCK_IN': CLOCK_IN,
    'CLOCK_OUT': CLOCK_OUT,
    'PICK_UP': PICKUP,
    'DROP_OFF': DROPOFF,
    'RETURN': RETURN,
    'COMPLETE': COMPLETE
  };

  factory TaskType(String type) {
    if (ALL.containsKey(type))
      return ALL[type];
    return TaskType._internal(type);
  }

  factory TaskType.fromJson(Map<String, dynamic> json) => _$TaskTypeFromJson(json);
  Map<String, dynamic> toJson() => _$TaskTypeToJson(this);

}