import '../assignment.dart';
import '../driver.dart';
import '../reference.dart';
import '../stop.dart';
import '../uid.dart';
import '../user.dart';
import 'uid_factory.dart';

import '../shipment.dart';

class ReferenceFactory {
  static Reference fromAssignment(Assignment assignment) {
    return Reference(UIDFactory.assignmentUID(assignment.id))..attributes = {
      'logistic_type': assignment.logisticType
    };
  }

  static Reference fromStop(Stop stop) {
    return Reference(stop.id != null ? UIDFactory.stopUID(stop.id) : UID('ST', stop.uid ?? ''))..attributes = {
      'type': stop.type
    };
  }

  static Reference fromShipment(Shipment shipment) {
    return Reference(UIDFactory.shipmentUID(shipment.id))..attributes = {
      'client_id': shipment.clientId.toString()
    };
  }

  static Reference fromDriver(Driver driver) {
    return Reference(UIDFactory.driverUID(driver.id))..attributes = {
      'name': '${driver.firstName} ${driver.lastName}'
    };
  }

  static Reference fromUser(User user) {
    return Reference(UIDFactory.userUID(user.id))..attributes = {
      'name': user.username,
    };
  }

}