import 'package:axlehire_flutter_model/src/axl_token.dart';
import 'package:flutter_test/flutter_test.dart';
import 'dart:convert';

import 'package:axlehire_flutter_model/axlehire_model.dart';

void main() {
  test('deserialize axl Token', () {
    String raw = """
    {
      "access_token": "R40CPyoFo1xxxxxxxxxxxxxxxxmV",
      "expires_at": 1577154781.400045,
      "expires_in": 7200000,
      "refresh_token": "TiDsJZIahyD45IxxxxxxxxxxxxS",
      "scope": "admin warehouse-manager dispatcher",
      "token_type": "Bearer"
    }
    """;
    AxlToken token = AxlToken.fromJson(jsonDecode(raw));
    expect(token.expiresTs, 1577154781400);
    expect(token.accessToken, 'R40CPyoFo1xxxxxxxxxxxxxxxxmV');
    expect(token.scopes.contains('admin'), true);
  });
}
